"pipe" command or any profile curve extrusion along curve, in RhinoCommon

I want to extrude curve along curve.
I have to create curved beams and specific profiles with specific profile curves.

I need to do it in RhinoCommon.
What is the rhinoCommon way of Pipe command? or extrude closed curve along curve?

I will break the long path curve into pieces and then I will extrude profile along curve, as I need to rationalize them too.
I am not finding the right way in Rhino Common, for extruding profile curve along a curve path…
If I need to write a c++ plugin then I am also happy to do that.

Please give me some clue and advise.

Best Regards

I would say you want Sweep, not extrude. If you Extrude, the section has the same orientation as the original no matter which way the path curve turns, whereas with Sweep, the section will keep its orientation relative to the curve along the curve (i.e. turn with the curve to create a constant section profile). In addition, you could use multiple profiles if you want. Pipe is pretty much a sweep 1 rail of a circle.

In RhinoCommon it’s
Rhino.Geometry.Brep.CreateFromSweep (Curve, IEnumerable(Curve), Boolean, Double)

There is also Brep.CreatePipe() if you want just round sections.

HTH, --Mitch

1 Like

Dear Mitch, Many Thanks for the explanation and solution !

For a straight pipe, use Extrusion.CreatePipeExtrusion
http://4.rhino3d.com/5/rhinocommon/html/M_Rhino_Geometry_Extrusion_CreatePipeExtrusion.htm

1 Like